## flannel 0.9.1~ds1

=== Makefile ===
.PHONY: test e2e-test cover gofmt gofmt-fix license-check clean tar.gz docker-push release docker-push-all flannel-git

# Registry used for publishing images
REGISTRY?=quay.io/coreos/flannel

# Default tag and architecture. Can be overridden
TAG?=$(shell git describe --tags --dirty)
ARCH?=amd64

# These variables can be overridden by setting an environment variable.
TEST_PACKAGES?=pkg/ip subnet subnet/etcdv2 network
TEST_PACKAGES_EXPANDED=$(TEST_PACKAGES:%=github.com/coreos/flannel/%)
PACKAGES?=$(TEST_PACKAGES) network
PACKAGES_EXPANDED=$(PACKAGES:%=github.com/coreos/flannel/%)

# Set the (cross) compiler to use for different architectures
ifeq ($(ARCH),amd64)
	LIB_DIR=/lib/x86_64-linux-gnu
	CC=gcc
endif
ifeq ($(ARCH),arm)
	LIB_DIR=/usr/arm-linux-gnueabihf/lib
	CC=arm-linux-gnueabihf-gcc
endif
ifeq ($(ARCH),arm64)
	LIB_DIR=/usr/aarch64-linux-gnu/lib
	CC=aarch64-linux-gnu-gcc
endif
ifeq ($(ARCH),ppc64le)
	LIB_DIR=/usr/powerpc64le-linux-gnu/lib
	CC=powerpc64le-linux-gnu-gcc
endif
ifeq ($(ARCH),s390x)
	LIB_DIR=/usr/s390x-linux-gnu/lib
	CC=s390x-linux-gnu-gcc
endif

GOARM=7

# List images with gcloud alpha container images list-tags gcr.io/google_containers/kube-cross
KUBE_CROSS_TAG=v1.8.3-1
IPTABLES_VERSION=1.4.21

dist/flanneld: $(shell find . -type f  -name '*.go')
	go build -o dist/flanneld \
	  -ldflags "-s -w -X github.com/coreos/flannel/version.Version=$(TAG)"

test: license-check gofmt
	go test -cover $(TEST_PACKAGES_EXPANDED)
	cd dist; ./mk-docker-opts_tests.sh

e2e-test: dist/flanneld-$(TAG)-$(ARCH).docker
	cd dist; ./functional-test.sh $(REGISTRY):$(TAG)-$(ARCH)

cover:
	# A single package must be given - e.g. 'PACKAGES=pkg/ip make cover'
	go test -coverprofile cover.out $(PACKAGES_EXPANDED)
	go tool cover -html=cover.out

# Throw an error if gofmt finds problems.
# "read" will return a failure return code if there is no output. This is inverted wth the "!"
gofmt:
	bash -c '! gofmt -d $(PACKAGES) 2>&1 | read'

gofmt-fix:
	gofmt -w $(PACKAGES)

license-check:
	./license-check.sh

update-glide:
	# go get -d -u github.com/Masterminds/glide
	glide update --strip-vendor
	# go get -d -u github.com/sgotti/glide-vc
	glide vc --only-code --no-tests

clean:
	rm -f dist/flanneld*
	rm -f dist/*.aci
	rm -f dist/*.docker
	rm -f dist/*.tar.gz

## Create a docker image on disk for a specific arch and tag
dist/flanneld-$(TAG)-$(ARCH).docker: dist/flanneld-$(ARCH) dist/iptables-$(ARCH)
	docker build -f Dockerfile.$(ARCH) -t $(REGISTRY):$(TAG)-$(ARCH) .
	docker save -o dist/flanneld-$(TAG)-$(ARCH).docker $(REGISTRY):$(TAG)-$(ARCH)

# amd64 gets an image with the suffix too (i.e. it's the default)
ifeq ($(ARCH),amd64)
	docker build -f Dockerfile.$(ARCH) -t $(REGISTRY):$(TAG) .
endif

## Create an ACI on disk for a specific arch and tag
dist/flanneld-$(TAG)-$(ARCH).aci: dist/flanneld-$(TAG)-$(ARCH).docker
	docker2aci dist/flanneld-$(TAG)-$(ARCH).docker
	mv quay.io-coreos-flannel-$(TAG)-$(ARCH).aci dist/flanneld-$(TAG)-$(ARCH).aci
	actool patch-manifest --replace --capability=CAP_NET_ADMIN \
      --mounts=run-flannel,path=/run/flannel,readOnly=false:etc-ssl-etcd,path=/etc/ssl/etcd,readOnly=true:dev-net,path=/dev/net,readOnly=false \
      dist/flanneld-$(TAG)-$(ARCH).aci

docker-push: dist/flanneld-$(TAG)-$(ARCH).docker
	docker push $(REGISTRY):$(TAG)-$(ARCH)

# amd64 gets an image with the suffix too (i.e. it's the default)
ifeq ($(ARCH),amd64)
	docker push $(REGISTRY):$(TAG)
endif

## Build an architecture specific flanneld binary
dist/flanneld-$(ARCH):
	# Build for other platforms with 'ARCH=$$ARCH make dist/flanneld-$$ARCH'
	# valid values for $$ARCH are [amd64 arm arm64 ppc64le s390x]
	docker run -e CC=$(CC) -e GOARM=$(GOARM) -e GOARCH=$(ARCH) \
		-u $(shell id -u):$(shell id -g) \
	    -v $(CURDIR):/go/src/github.com/coreos/flannel:ro \
        -v $(CURDIR)/dist:/go/src/github.com/coreos/flannel/dist \
	    gcr.io/google_containers/kube-cross:$(KUBE_CROSS_TAG) /bin/bash -c '\
		cd /go/src/github.com/coreos/flannel && \
		CGO_ENABLED=1 make -e dist/flanneld && \
		mv dist/flanneld dist/flanneld-$(ARCH) && \
		file dist/flanneld-$(ARCH)'

## Build an architecture specific iptables binary
dist/iptables-$(ARCH):
	docker run -e CC=$(CC) -e GOARM=$(GOARM) -e GOARCH=$(ARCH) \
			-u $(shell id -u):$(shell id -g) \
            -v $(CURDIR):/go/src/github.com/coreos/flannel:ro \
            -v $(CURDIR)/dist:/go/src/github.com/coreos/flannel/dist \
            gcr.io/google_containers/kube-cross:$(KUBE_CROSS_TAG) /bin/bash -c '\
            curl -sSL http://www.netfilter.org/projects/iptables/files/iptables-$(IPTABLES_VERSION).tar.bz2 | tar -jxv && \
            cd iptables-$(IPTABLES_VERSION) && \
            ./configure \
                --prefix=/usr \
                --mandir=/usr/man \
                --disable-shared \
                --disable-devel \
                --disable-nftables \
                --enable-static \
                --host=amd64 && \
            make && \
            cp iptables/xtables-multi /go/src/github.com/coreos/flannel/dist/iptables-$(ARCH) && \
            cd /go/src/github.com/coreos/flannel && \
            file dist/iptables-$(ARCH)'

## Build a .tar.gz for the amd64 ppc64le arm arm64 flanneld binary
tar.gz:	
	ARCH=amd64 make dist/flanneld-amd64
	tar --transform='flags=r;s|-amd64||' -zcvf dist/flannel-$(TAG)-linux-amd64.tar.gz -C dist flanneld-amd64 mk-docker-opts.sh ../README.md
	tar -tvf dist/flannel-$(TAG)-linux-amd64.tar.gz
	ARCH=ppc64le make dist/flanneld-ppc64le
	tar --transform='flags=r;s|-ppc64le||' -zcvf dist/flannel-$(TAG)-linux-ppc64le.tar.gz -C dist flanneld-ppc64le mk-docker-opts.sh ../README.md
	tar -tvf dist/flannel-$(TAG)-linux-ppc64le.tar.gz
	ARCH=arm make dist/flanneld-arm
	tar --transform='flags=r;s|-arm||' -zcvf dist/flannel-$(TAG)-linux-arm.tar.gz -C dist flanneld-arm mk-docker-opts.sh ../README.md
	tar -tvf dist/flannel-$(TAG)-linux-arm.tar.gz
	ARCH=arm64 make dist/flanneld-arm64
	tar --transform='flags=r;s|-arm64||' -zcvf dist/flannel-$(TAG)-linux-arm64.tar.gz -C dist flanneld-arm64 mk-docker-opts.sh ../README.md
	tar -tvf dist/flannel-$(TAG)-linux-arm64.tar.gz
	ARCH=s390x make dist/flanneld-s390x
	tar --transform='flags=r;s|-s390x||' -zcvf dist/flannel-$(TAG)-linux-s390x.tar.gz -C dist flanneld-s390x mk-docker-opts.sh ../README.md
	tar -tvf dist/flannel-$(TAG)-linux-s390x.tar.gz

## Make a release after creating a tag
release: tar.gz
	ARCH=amd64 make dist/flanneld-$(TAG)-amd64.aci
	ARCH=arm make dist/flanneld-$(TAG)-arm.aci
	ARCH=arm64 make dist/flanneld-$(TAG)-arm64.aci
	ARCH=ppc64le make dist/flanneld-$(TAG)-ppc64le.aci
	ARCH=s390x make dist/flanneld-$(TAG)-s390x.aci
	@echo "Everything should be built for $(TAG)"
	@echo "Add all *.aci, flanneld-* and *.tar.gz files from dist/ to the Github release"
	@echo "Use make docker-push-all to push the images to a registry"

docker-push-all:
	ARCH=amd64 make docker-push
	ARCH=arm make docker-push
	ARCH=arm64 make docker-push
	ARCH=ppc64le make docker-push
	ARCH=s390x make docker-push

flannel-git:
	ARCH=amd64 REGISTRY=quay.io/coreos/flannel-git make clean dist/flanneld-$(TAG)-amd64.docker docker-push
	docker build -f Dockerfile.amd64 -t quay.io/coreos/flannel-git .
	docker push quay.io/coreos/flannel-git
	ARCH=arm REGISTRY=quay.io/coreos/flannel-git make clean dist/flanneld-$(TAG)-arm.docker docker-push
	ARCH=arm64 REGISTRY=quay.io/coreos/flannel-git make clean dist/flanneld-$(TAG)-arm64.docker docker-push
	ARCH=ppc64le REGISTRY=quay.io/coreos/flannel-git make clean dist/flanneld-$(TAG)-ppc64le.docker docker-push
	ARCH=s390x REGISTRY=quay.io/coreos/flannel-git make clean dist/flanneld-$(TAG)-s390x.docker docker-push

install:
	# This is intended as just a developer convenience to help speed up non-containerized builds
	# It is NOT how you install flannel
	CGO_ENABLED=1 go install -v github.com/coreos/flannel

minikube-start:
	minikube start --network-plugin cni

minikube-build-image: dist/iptables-amd64
	CGO_ENABLED=1 go build -v -o dist/flanneld-amd64
	# Make sure the minikube docker is being used "eval $(minikube docker-env)"
	sh -c 'eval $$(minikube docker-env) && docker build -f Dockerfile.amd64 -t flannel/minikube .'

minikube-deploy-flannel:
	kubectl apply -f Documentation/minikube.yml

minikube-remove-flannel:
	kubectl delete -f Documentation/minikube.yml

minikube-restart-pod:
	# Use this to pick up a new image
	kubectl delete pods -l app=flannel --grace-period=0

kubernetes-logs:
	kubectl logs `kubectl get po -l app=flannel -o=custom-columns=NAME:metadata.name --no-headers=true` -c kube-flannel -f

LOCAL_IP_ENV?=$(shell ip route get 8.8.8.8 | head -1 | awk '{print $$7}')
run-etcd: stop-etcd
	docker run --detach \
	-p 2379:2379 \
	--name flannel-etcd quay.io/coreos/etcd \
	etcd \
	--advertise-client-urls "http://$(LOCAL_IP_ENV):2379,http://127.0.0.1:2379,http://$(LOCAL_IP_ENV):4001,http://127.0.0.1:4001" \
	--listen-client-urls "http://0.0.0.0:2379,http://0.0.0.0:4001"

stop-etcd:
	@-docker rm -f flannel-etcd

K8S_VERSION=v1.6.6
run-k8s-apiserver: stop-k8s-apiserver
	docker run --detach --net=host \
	  --name calico-k8s-apiserver \
  	gcr.io/google_containers/hyperkube-amd64:$(K8S_VERSION) \
		  /hyperkube apiserver --etcd-servers=http://$(LOCAL_IP_ENV):2379 \
		  --service-cluster-ip-range=10.101.0.0/16

stop-k8s-apiserver:
	@-docker rm -f calico-k8s-apiserver

run-local-kube-flannel-with-prereqs: run-etcd run-k8s-apiserver dist/flanneld
	while ! kubectl apply -f dist/fake-node.yaml; do sleep 1; done
	$(MAKE) run-local-kube-flannel

run-local-kube-flannel:
	# Currently this requires the netconf to be in /etc/kube-flannel/net-conf.json
	sudo NODE_NAME=test dist/flanneld --kube-subnet-mgr --kube-api-url http://127.0.0.1:8080

## flannel 0.5.5~ds1

=== debian/changelog ===
flannel (0.5.5~ds1-2) unstable; urgency=medium

  * Update patch for recent golang-github-vishvananda-netlink B-D
  * Use https for Vcs-Git URL.

 -- Tim Potter <tpot@hpe.com>  Fri, 10 Feb 2017 15:55:34 +1100

flannel (0.5.5~ds1-1) unstable; urgency=medium

  * Initial release (Closes: #829217)

 -- Tim Potter <tpot@hpe.com>  Fri, 22 Jul 2016 08:05:13 +1000

=== debian/control ===
Source: flannel
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>=9),
               dh-golang,
               golang-github-coreos-go-iptables-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-context-dev,
               golang-github-gorilla-mux-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-vishvananda-netns-dev,
               golang-glog-dev,
               golang-go
Standards-Version: 3.9.8
Homepage: https://github.com/coreos/flannel
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/flannel.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/flannel.git
XS-Go-Import-Path: github.com/coreos/flannel

Package: flannel
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Etcd backed network fabric for containers
 Flannel is a virtual network that gives a subnet to each host for
 use with container runtimes.
 .
 Platforms like Google's Kubernetes assume that each container (pod)
 has a unique, routable IP inside the cluster. The advantage of this
 model is that it reduces the complexity of doing port mapping.

=== debian/watch ===
version=3
opts=repacksuffix=~ds1,dversionmangle=s{[~+](?:ds|dfsg)\d*$}{},repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/flannel-$1\.tar\.gz/ \
  https://github.com/coreos/flannel/tags .*/v?(\d\S*)\.tar\.gz

## flannel 0.9.1~ds1

=== debian/changelog ===
flannel (0.9.1~ds1-1) unstable; urgency=medium

  * New upstream version.
  * Remove unneeded patches, update d/copyright and d/control for
    move to Glide from Godeps, and large number of new dependencies.

 -- Tim Potter <tpot@hpe.com>  Tue, 21 Nov 2017 15:11:28 +1100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,39 @@
 Source: flannel
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Tim Potter <tpot@hpe.com>
 Build-Depends: debhelper (>=9),
                dh-golang,
+               golang-etcd-server-dev,
                golang-github-coreos-go-iptables-dev,
                golang-github-coreos-go-systemd-dev,
-               golang-github-gorilla-context-dev,
-               golang-github-gorilla-mux-dev,
+               golang-github-coreos-pkg-dev,
+               golang-github-davecgh-go-spew-dev,
+               golang-github-denverdino-aliyungo-dev,
+               golang-github-ghodss-yaml-dev,
+               golang-github-go-ini-ini-dev,
+               golang-github-go-openapi-spec-dev,
+               golang-github-gogo-protobuf-dev,
+               golang-github-google-gofuzz-dev,
+               golang-github-howeyc-gopass-dev,
+               golang-github-imdario-mergo-dev,
+               golang-github-jmespath-go-jmespath-dev,
+               golang-github-joho-godotenv-dev,
+               golang-github-jonboulle-clockwork-dev,
+               golang-github-juju-ratelimit-dev,
+               golang-github-spf13-pflag-dev,
+               golang-github-ugorji-go-codec-dev,
                golang-github-vishvananda-netlink-dev,
-               golang-github-vishvananda-netns-dev,
                golang-glog-dev,
-               golang-go
-Standards-Version: 3.9.8
+               golang-go,
+               golang-golang-x-oauth2-google-dev,
+               golang-google-api-dev,
+               golang-google-appengine-dev,
+               golang-google-cloud-compute-metadata-dev,
+               golang-gopkg-inf.v0-dev,
+               golang-gopkg-yaml.v2-dev
+Standards-Version: 4.1.1
 Homepage: https://github.com/coreos/flannel
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/flannel.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/flannel.git

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install
	rm -r debian/flannel/usr/share/gocode

=== debian/watch ===
version=3
opts=repacksuffix=~ds1,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,dversionmangle=s{[~+](?:ds|dfsg)\d*$}{},repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/flannel-$1\.tar\.gz/ \
  https://github.com/coreos/flannel/tags .*/v?(\d\S*)\.tar\.gz
